      PROGRAM PREP93
C**********************************************************************
C* July 1993                                                          *
C*                      Program PREP93                                *
C*                                                                    *
C*                       by M. Nardelli                               *
C*       Istituto di Chimica Generale della Universit di Parma       *
C*  Centro di Studio per la Strutturistica Diffrattometrica del CNR.  *
C*            Viale delle Scienze 78, I-43100 Parma, Italy            *
C*                                                                    *
C*                ----------------------------                        *
C*                                                                    *
C* This program set up the input files for PARST and for THMV7 from   *
C* the name.lst file obtained by SHELXL-93.                           *
C* The computer asks for the names of the input and output files that *
C* must be keyed in by the user.                                      *
C*                                                                    *
C* N.B. The output files require a minimum of editing before to be    *
C*      used. In particular instructions for L.S. planes or lines,    *
C*      rings, comparison of molecules or moieties must e added.      *
C*                                                                    *
C*                      SUBROUTINES                                   *
C*                                                                    *
C* MINUMA(STR,N)                                                      *
C* SYMMCOD(TIT)                                                       *
C* BLOCK DATA                                                         *
C*                                                                    *
C**********************************************************************
 
      CHARACTER*1 TIT(120),ATM(4),AT(2,94),AT2,NU(10),BRV,SAT(2,20),
     1 ATMP(4,200),ATMH(4,200),SYM(100,48)
      CHARACTER*14 FILIN,FILPAR,FILTHM
      DIMENSION X(3),U(6),SX(3),SU(6),C(3),A(3),SC(3),SA(3),NSPE(20),
     1 XP(3,200),XH(3,200),SXP(3,200),SXH(3,200),UP(6,200),UH(6,200),
     2 SUP(6,200),SUH(6,200)
      COMMON/GRP1/AT,NU
     1      /GRP2/PA(94)
C-----Assign input and output files
      WRITE(*,100)
100   FORMAT(' Key in the name of the input file'/' ?>')
      READ(*,'(A14)')FILIN
      OPEN(UNIT=13,FILE=FILIN,FORM='FORMATTED')
      REWIND(UNIT=13)
      WRITE(*,101)
101   FORMAT(' Key in the name of output file for PARST'/' ?>')
      READ(*,'(A14)')FILPAR
      OPEN(UNIT=15,FILE=FILPAR,FORM='FORMATTED')
      REWIND(UNIT=15)
      WRITE(*,102)
102   FORMAT(' Key in the name of output file for THMV'/' ?>')
      READ(*,'(A14)')FILTHM
      OPEN(UNIT=16,FILE=FILTHM,FORM='FORMATTED')
      REWIND(UNIT=16)
      OPEN(UNIT=17,STATUS='SCRATCH',FORM='FORMATTED')
      REWIND(UNIT=17)
      OPEN(UNIT=18,STATUS='SCRATCH',FORM='FORMATTED')
      REWIND(UNIT=18)
C-----Assigns zeros to counters and codes
      N=0
      NT=0
      NP=0
      NH=0
      KDC=0
      KKDC=0
      KKD=0
C-----Read data
      DO 14 I=1,50
      READ(13,'(120A1)')TIT
      IF(TIT(2).EQ.' '.AND.TIT(3).EQ.' '.AND.TIT(4).EQ.' '.AND.
     1 TIT(5).EQ.' ')GO TO 14
      NC=120
      CALL MINUMA(TIT,NC)
      IF(TIT(2).EQ.'T'.AND.TIT(3).EQ.'I'.AND.TIT(4).EQ.'T'.AND.TIT(5)
     1 .EQ.'L') THEN
      WRITE(15,'(70A1)')(TIT(L),L=7,76)
      WRITE(16,'(70A1)')(TIT(L),L=7,76)
      ELSEIF(TIT(2).EQ.'C'.AND.TIT(3).EQ.'E'.AND.TIT(4).EQ.'L'.AND.
     1 TIT(5).EQ.'L') THEN
      WRITE(18,'(114A1)')(TIT(L),L=7,120)
      BACKSPACE 18
      READ(18,*)ALA,C,A
      ELSEIF(TIT(2).EQ.'Z'.AND.TIT(3).EQ.'E'.AND.TIT(4).EQ.'R'.AND.
     1 TIT(5).EQ.'R') THEN
      WRITE(18,'(114A1)')(TIT(L),L=7,120)
      NB=0
      DO 15 L=7,120
      IF(TIT(L).NE.' ') GO TO 15
      IF(TIT(L+1).EQ.' ') GO TO 32
      NB=NB+1
15    CONTINUE
32    BACKSPACE 18
      DO 33 K=1,3
33    SA(I)=0.0
      IF(NB.GT.3) THEN
      READ(18,*)IZ,SC,SA
      ELSE
      READ(18,*)IZ,SC
      ENDIF
      ELSEIF(TIT(2).EQ.'L'.AND.TIT(3).EQ.'A'.AND.TIT(4).EQ.'T'.AND.
     1 TIT(5).EQ.'T') THEN
      WRITE(18,'(114A1)')(TIT(L),L=7,120)
      BACKSPACE 18
      READ(18,*)LATT
      IF(ABS(LATT).EQ.1)BRV='P'
      IF(ABS(LATT).EQ.2)BRV='I'
      IF(ABS(LATT).EQ.3)BRV='R'
      IF(ABS(LATT).EQ.4)BRV='F'
      IF(ABS(LATT).EQ.5)BRV='A'
      IF(ABS(LATT).EQ.6)BRV='B'
      IF(ABS(LATT).EQ.7)BRV='C'
      WRITE(15,'(A1)')BRV
      KKDC=1
      ELSEIF(TIT(2).EQ.'S'.AND.TIT(3).EQ.'Y'.AND.TIT(4).EQ.'M'.AND.
     1 TIT(5).EQ.'M') THEN
      CALL SYMMCOD(TIT)
      KKD=KKD+1
      DO 26 L=1,100
26    SYM(L,KKD)=TIT(L+6)
      ELSEIF(TIT(2).EQ.'S'.AND.TIT(3).EQ.'F'.AND.TIT(4).EQ.'A'.AND.
     1 TIT(5).EQ.'C') THEN
      NAT=0
      KDC=0
      DO 31 L=7,120
      IF(KDC.EQ.0)GO TO 30
      KDC=0
      GO TO 31
30    IF(TIT(L).EQ.' '.OR.KDC.EQ.1) GO TO 31
      NAT=NAT+1
      SAT(1,NAT)=TIT(L)
      SAT(2,NAT)=TIT(L+1)
      KDC=1
31    CONTINUE
      ELSEIF(TIT(2).EQ.'U'.AND.TIT(3).EQ.'N'.AND.TIT(4).EQ.'I'.AND.
     1 TIT(5).EQ.'T') THEN
      WRITE(18,'(114A1)')(TIT(L),L=7,120)
      BACKSPACE 18
      READ(18,*,END=29)(NSPE(L),L=1,20)
29    NAT=0
      DO 16 J=1,20
      IF(NSPE(J).EQ.0)GO TO 17
      NAT=NAT+1
16    NSPE(NAT)=NSPE(J)/IZ
17    CONTINUE
      ENDIF
14    CONTINUE
C-----Read coordinate table
1     READ(13,'(120A1)')TIT
      NC=37
      CALL MINUMA(TIT,NC)
      IF(TIT(2).NE.'A')GO TO 1
      IF(TIT(3).NE.'T')GO TO 1
      IF(TIT(4).NE.'O')GO TO 1
      IF(TIT(5).NE.'M')GO TO 1
      IF(TIT(17).NE.'X')GO TO 1
      IF(TIT(27).NE.'Y')GO TO 1
      IF(TIT(37).NE.'Z')GO TO 1
2     READ(13,'(120A1)')TIT
      READ(13,'(120A1)')TIT
C     WRITE(15,'(120A1)')TIT
      IF(TIT(2).EQ.' '.AND.TIT(3).EQ.' '.AND.TIT(4).EQ.' '.AND.
     1 TIT(5).EQ.' ')GO TO 9
      BACKSPACE 13
      N=N+1
      READ(13,104)ATM,X,PE,U,SX,SU
104   FORMAT(1X,4A1,5X,3(2X,F8.5),5X,F7.5,2X,6(2X,F8.5)/
     1 10X,3(2X,F8.5),14X,6(2X,F8.5))
      NC=4
      DO 3 I=2,5
3     TIT(I)=ATM(I)
      CALL MINUMA(TIT,NC)
      DO 4 I=2,5
4     ATM(I)=TIT(I)
      DO 7 I=1,94
      AT2=ATM(2)
      DO 5 J=1,10
      IF(AT2.NE.NU(J))GO TO 5
      AT2=' '
      GO TO 6
5     CONTINUE
6     IF(ATM(1).EQ.AT(1,I).AND.AT2.EQ.AT(2,I))GO TO 8
7     CONTINUE
      PRINT'(A)',' Atom '
      WRITE(*,'(2X,2A1)')ATM(1),ATM(2)
      PRINT'(A)',' does not exists'
      GO TO 2
8     AW=PA(I)
C-----Separate H atoms
      IF(ATM(1).EQ.AT(1,1).AND.AT2.EQ.AT(2,1))THEN
      NH=NH+1
      DO 18 L=1,4
18    ATMH(L,NH)=ATM(L)
      DO 19 K=1,3
      XH(K,NH)=X(K)
19    SXH(K,NH)=SX(K)
      DO 20 K=1,6
      UH(K,NH)=U(K)
20    SUH(K,NH)=SU(K)
      ELSE
C-----Separate non-H atoms
      NP=NP+1
      DO 21 L=1,4
21    ATMP(L,NP)=ATM(L)
      DO 22 K=1,3
      XP(K,NP)=X(K)
22    SXP(K,NP)=SX(K)
      DO 23 K=1,6
      UP(K,NP)=U(K)
23    SUP(K,NP)=SU(K)
      ENDIF
C-----Set up file for TMV
      IF(U(2).LT.1E-5.AND.U(3).LT.1E-5) GO TO 2
      NT=NT+1
      RIS=U(4)
      U(4)=U(6)
      U(6)=RIS
      RIS=SU(4)
      SU(4)=SU(6)
      SU(6)=RIS
      WRITE(17,106)ATM,X,AW,PE,U,SU,ATM
106   FORMAT(4A1,23X,3F9.6,2F5.1/6F9.6/6F10.5,4A1)
      GO TO 2
C-----Write the file for PARST
9     IF(KKDC.EQ.0)WRITE(15,'(''P'')')
      WRITE(15,'(I3,'',2.5,4.0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,2,0'')')N
      WRITE(15,'(I2,I3,F8.5)')NAT,IZ,ALA
      WRITE(15,109)((SAT(L,K),L=1,2),NSPE(K),K=1,NAT)
109   FORMAT(20('''',2A1,'''',I3,1X))
      WRITE(15,'(3(F8.4,1X),3(F5.4,1X),3(F6.2,1X),3(F3.2,1X))')
     1 C,SC,A,SA
      WRITE(15,103)
103   FORMAT(' (1X,4A1,6F8.5/1X,6F8.5/1X,6F8.5)')                                 ')
      DO 24 I=1,NP
24    WRITE(15,105)(ATMP(L,I),L=1,4),(XP(K,I),K=1,3),(UP(J,I),J=1,6),
     1 (SXP(K,I),K=1,3),(SUP(J,I),J=1,6)
105   FORMAT(1X,4A1,6F8.5/1X,6F8.5/1X,6F8.5)
      DO 25 I=1,NH
25    WRITE(15,105)(ATMH(L,I),L=1,4),(XH(K,I),K=1,3),(UH(J,I),J=1,6),
     1 (SXH(K,I),K=1,3),(SUH(J,I),J=1,6)
      IA=2
      IC=-1
      IF(LATT.LT.0)IC=1
      WRITE(15,'(3I4)')IC,KKD,IA
      IF(KKD.EQ.0) GO TO 28
      DO 27 L=1,KKD
27    WRITE(15,'(100A1)')(SYM(K,L),K=1,100)
C-----Write the file for TMV
28    WRITE(16,107)C,A
107   FORMAT(F6.3,3X,F7.3,4X,F7.3,3X,F6.2,2(4X,F6.2),7X,'0',3X,'0')
      MNT=-NT
      WRITE(16,108)MNT,NT
108   FORMAT(I5,2(4X,'1'),4X,'8',3(4X,'0'),I5,9X,'1',7X,'-1')
      REWIND 17
      N3=3*NT
      DO 10 I=1,N3-3
      READ(17,'(120A1)',END=12)TIT
      WRITE(16,'(120A1)')TIT
      READ(17,'(120A1)',END=12)TIT
      WRITE(16,'(120A1)')TIT
10    READ(17,'(120A1)',END=12)TIT
12    REWIND 17
      DO 11 I=1,N3-3
      READ(17,'(120A1)',END=13)TIT
      READ(17,'(120A1)',END=13)TIT
      READ(17,'(120A1)',END=13)TIT
11    WRITE(16,'(120A1)')TIT
13    CLOSE(UNIT=13)
      CLOSE(UNIT=15)
      CLOSE(UNIT=16)
      CLOSE(UNIT=17)
      CLOSE(UNIT=18)
      STOP
      END
 
      SUBROUTINE MINUMA(STR,N)
C-----This routine transforms the lower case characters into upper
C-----case characters, in a string of N characters (max.120)
      CHARACTER*1 MINU(26),MAIU(26),STR(120)
      DATA MINU/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     1 'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      DATA MAIU/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     1 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      DO 2 I=1,N
      DO 1 J=1,26
      IF(STR(I).NE.MINU(J)) GO TO 1
      STR(I)=MAIU(J)
      GO TO 2
1     CONTINUE
2     CONTINUE
      RETURN
      END
 
      BLOCK DATA
      CHARACTER*1 AT(2,94),NU(10)
      COMMON/GRP1/AT,NU
     1      /GRP2/PA(94)
      DATA AT/'H',' ','H','E','L','I','B','E','B',' ',
     9'C',' ','N',' ','O',' ','F',' ','N','E',
     1'N','A','M','G','A','L','S','I','P',' ',
     1'S',' ','C','L','A','R','K',' ','C','A','S','C',
     2'T','I','V',' ','C','R','M','N','F','E',
     2'C','O','N','I','C','U','Z','N','G','A','G','E',
     3'A','S','S','E','B','R','K','R','R','B',
     3'S','R','Y',' ','Z','R','N','B','M','O','T','C',
     4'R','U','R','H','P','D','A','G','C','D',
     4'I','N','S','N','S','B','T','E','I',' ','X','E',
     5'C','S','B','A','L','A','C','E','P','R',
     5'N','D','P','M','S','M','E','U','G','D','T','B',
     6'D','Y','H','O','E','R','T','M','Y','B',
     6'L','U','H','F','T','A','W',' ','R','E','O','S',
     7'I','R','P','T','A','U','H','G','T','L',
     7'P','B','B','I','P','O','A','T','R','N','F','R',
     8'R','A','A','C','T','H','P','A','U',' ','N','P','P','U'/
      DATA PA/1.0079,4.0026,6.941,9.01218,10.81,12.011,14.0067,
     A15.9994,18.9984,20.179,22.98977,24.305,26.98154,28.086,
     B30.97376,32.06,35.453,39.948,39.098,40.08,44.9559,47.9,
     C50.9415,51.996,54.938,55.847,58.9332,58.71,63.546,65.38,
     D69.72,72.59,74.9216,78.96,79.904,83.8,85.4678,87.62,
     E88.9059,91.22,92.9064,95.94,98.9062,101.07,102.9055,
     F106.4,107.868,112.4,114.82,118.69,121.75,127.6,126.9045,
     G131.3,132.9044,137.34,138.9055,140.12,140.9077,144.24,
     H147.,150.4,151.96,157.25,158.9254,162.5,164.9304,167.26,
     I168.9342,173.04,174.97,178.49,180.9479,183.85,186.2,190.2,
     L192.22,195.09,196.9665,200.59,204.37,207.2,208.9804,210.,
     M210.,222.,223.,226.0254,227.,232.0381,231.0359,238.029,
     N237.0482,242./
      DATA NU/'0','1','2','3','4','5','6','7','8','9'/
      END
 
      SUBROUTINE SYMMCOD(TIT)
C-----Changes a SYMM string of SHELXL92 for PARST
      CHARACTER*1 TIT(120),AA
      DO 1 I=7,120
      IF(TIT(I).NE.'0')GO TO 1
      IF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'5')THEN
      TIT(I)='1'
      TIT(I+1)='/'
      TIT(I+2)='2'
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'2'.AND.TIT(I+3).EQ.'5')
     1 THEN
      TIT(I)='1'
      TIT(I+1)='/'
      TIT(I+2)='4'
      TIT(I+3)=' '
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'7'.AND.TIT(I+3).EQ.'5')
     1 THEN
      TIT(I)='3'
      TIT(I+1)='/'
      TIT(I+2)='4'
      TIT(I+3)=' '
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'3')THEN
      AA=TIT(I+2)
      TIT(I)='1'
      TIT(I+1)='/'
      TIT(I+2)='3'
      DO 2 K=I+3,I+10
      IF(TIT(K).EQ.AA)TIT(K)=' '
2     CONTINUE
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'6')THEN
      AA=TIT(I+2)
      TIT(I)='2'
      TIT(I+1)='/'
      TIT(I+2)='3'
      DO 3 K=I+3,I+10
      IF(TIT(K).EQ.AA)TIT(K)=' '
3     CONTINUE
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'1'.AND.TIT(I+3).EQ.'6')
     1 THEN
      AA=TIT(I+3)
      TIT(I)='1'
      TIT(I+1)='/'
      TIT(I+2)='6'
      DO 4 K=I+3,I+10
      IF(TIT(K).EQ.AA)TIT(K)=' '
4     CONTINUE
      ELSEIF(TIT(I+1).EQ.'.'.AND.TIT(I+2).EQ.'8'.AND.TIT(I+3).EQ.'3')
     1 THEN
      AA=TIT(I+3)
      TIT(I)='5'
      TIT(I+1)='/'
      TIT(I+2)='6'
      DO 5 K=I+3,I+10
      IF(TIT(K).EQ.AA)TIT(K)=' '
5     CONTINUE
      ENDIF
1     CONTINUE
      DO 8 L=1,5
      DO 7 I=7,119
      IF(TIT(I).NE.' ') GO TO 7
      DO 6 K=I,119
6     TIT(K)=TIT(K+1)
7     CONTINUE
8     CONTINUE
      RETURN
      END
